function featparams = defaultfeatparams(featparams, ind_classes)

% which features to use:
if ~isfield(featparams, 'spOnly')
    featparams.spOnly = 0;
end;
if ~isfield(featparams, 'segOnly')
    featparams.segOnly = 0;
end;
if ~isfield(featparams, 'segFeature')
   featparams.segFeature = 1;
end;
if ~isfield(featparams, 'chowliuFeature')
   featparams.chowliuFeature = 1;
end;
if ~isfield(featparams, 'SceneFeature')
   featparams.SceneFeature = 1;
end;
if ~isfield(featparams, 'SceneSupressZFeature')
   featparams.SceneSupressZFeature = 0;
end;
if ~isfield(featparams, 'SceneBoostZFeature')
   featparams.SceneBoostZFeature = 1;
end;
if ~isfield(featparams, 'usesupressinboost')
   featparams.usesupressinboost = 1;
end;
if ~isfield(featparams, 'suppress_gamma')
   featparams.suppress_gamma = 1;
end;
if ~isfield(featparams, 'det_classes')
    featparams.det_classes = [];
end;
if ~isfield(featparams, 'ind_classes') && nargin >= 2
   featparams.ind_classes = ind_classes;
end;
% if ~isfield(featparams, 'topK')
%    featparams.topK = 3;
% end;
if ~isfield(featparams, 'pascalloss')
   featparams.pascalloss = 1;
end;

% You may use more features as you want
if ~isfield(featparams, 'useSPLocationFeature')
   featparams.useSPLocationFeature = 0;
end;
if ~isfield(featparams, 'useSSLocationFeature')
   featparams.useSSLocationFeature = 0;
end;
if ~isfield(featparams, 'useFgBg')
   featparams.useFgBg = 0;
end;
if ~isfield(featparams, 'useClassSP')
   featparams.useClassSP = 0;
end;

% loss factors:
if ~isfield(featparams, 'superpixfactor')
   featparams.superpixfactor = 5;
end;
if ~isfield(featparams, 'supersegfactor')
   featparams.supersegfactor = 1;
end;
if ~isfield(featparams, 'Zfactor')
   featparams.Zfactor = 5;
end;
if ~isfield(featparams, 'Bfactor')
   featparams.Bfactor = 30;
end;
if ~isfield(featparams, 'Scenefactor')
   featparams.Scenefactor = 1;
end;

% other
if ~isfield(featparams, 'use1_meta')
   featparams.use1_meta = 0;
end;

if ~isfield(featparams, 'uselogistic')
   featparams.uselogistic = 1;
end;

if ~isfield(featparams, 'uselogisticScene')
    featparams.uselogisticScene = 1;
end;

if ~isfield(featparams, 'boxthresh')
   featparams.boxthresh = 0.5;
end;


